from read_chirp_data import *
from utility import *
#import nix_helpers as nh 
import matplotlib.pyplot as plt
import numpy as np
from IPython import embed



data_dir = "../data"
dataset = "2018-11-09-ad-invivo-1" 
data = ("2018-11-09-ad-invivo-1", "2018-11-09-ae-invivo-1", "2018-11-09-ag-invivo-1", "2018-11-13-aa-invivo-1", "2018-11-13-ac-invivo-1", "2018-11-13-ad-invivo-1", "2018-11-13-ah-invivo-1", "2018-11-13-ai-invivo-1", "2018-11-13-aj-invivo-1", "2018-11-13-ak-invivo-1", "2018-11-13-al-invivo-1", "2018-11-14-aa-invivo-1", "2018-11-14-ac-invivo-1", "2018-11-14-ad-invivo-1", "2018-11-14-af-invivo-1", "2018-11-14-ag-invivo-1", "2018-11-14-ah-invivo-1", "2018-11-14-ai-invivo-1", "2018-11-14-ak-invivo-1", "2018-11-14-al-invivo-1", "2018-11-14-am-invivo-1", "2018-11-14-an-invivo-1")



#for dataset in data:
eod = read_chirp_eod(os.path.join(data_dir, dataset))
times = read_chirp_times(os.path.join(data_dir, dataset))
df_map = map_keys(eod)



#die äußere Schleife geht für alle Keys durch und somit durch alle dfs
#die innnere Schleife bildet die 16 Wiederholungen einer Frequenz ab
for i in df_map.keys():
	freq = list(df_map[i]) 
	fig,axs = plt.subplots(2, 2, sharex = True, sharey = True)

	for idx, k in enumerate(freq):
		ct = times[k]
		e1 = eod[k]
		zeit = e1[0]
		eods = e1[1]
	
		if idx <= 3:
			axs[0, 0].plot(zeit, eods, color= 'blue', linewidth = 0.25)
			axs[0, 0].scatter(np.asarray(ct), np.ones(len(ct))*3, color = 'green', s= 22)
		elif 4<= idx <= 7:
			axs[0, 1].plot(zeit, eods, color= 'blue', linewidth = 0.25)
			axs[0, 1].scatter(np.asarray(ct), np.ones(len(ct))*3, color = 'green', s= 22)
		elif 8<= idx <= 11:
			axs[1, 0].plot(zeit, eods, color= 'blue', linewidth = 0.25)
			axs[1, 0].scatter(np.asarray(ct), np.ones(len(ct))*3, color = 'green', s= 22)
		else: 
			axs[1, 1].plot(zeit, eods, color= 'blue', linewidth = 0.25)
			axs[1, 1].scatter(np.asarray(ct), np.ones(len(ct))*3, color = 'green', s= 22)


fig.suptitle('EOD for chirps', fontsize = 16)
axs[0,0].set_ylabel('Amplitude [mV]') 
axs[0,1].set_xlabel('Amplitude [mV]')
axs[1,0].set_xlabel('Time [ms]')
axs[1,1].set_xlabel('Time [ms]')



#for i in df_map.keys():

freq = list(df_map['-50Hz'])
ls_mod = []
ls_beat = []
for k in freq: 
	e1 = eod[k]
	zeit = np.asarray(e1[0])
	ampl = np.asarray(e1[1])

	ct = times[k]
	for chirp in ct:
		time_cut = zeit[(zeit > chirp-10) & (zeit < chirp+10)]
		eods_cut = ampl[(zeit > chirp-10) & (zeit < chirp+10)]
		beat_cut = ampl[(zeit > chirp-55) & (zeit < chirp-10)]
		
		chirp_mod = np.std(eods_cut) #Std vom Bereich um den Chirp
		ls_mod.append(chirp_mod) #in die richtige Reihenfolge bringen?
		#momentan nicht nach Chirp-Platz sortiert, sondern nacheinander

		#erst beat_cuts auf die gleiche Länge bringen!
		ls_beat.append(beat_cut)

#beat_mod = np.std(ls_beat) #Std vom Bereich vor dem Chirp
plt.figure()
plt.scatter(np.arange(0,len(ls_mod),1), ls_mod)
plt.scatter(np.arange(0,len(ls_mod),1), np.ones(len(ls_mod))/2, color = 'violet')
plt.show()



#Chirps einer Phase zuordnen - zusammen plotten?
